/// <reference types="node" />
/// <reference types="node" />
import { EventEmitter } from 'events';
import { Inflates } from './buffer';
export type LiveOptions = {
    protover?: 1 | 2 | 3;
    key?: string;
    authBody?: any;
    uid?: number;
    buvid?: string;
};
export declare const relayEvent: unique symbol;
declare class NiceEventEmitter extends EventEmitter {
    emit(eventName: string | symbol, ...params: any[]): boolean;
}
export declare class Live extends NiceEventEmitter {
    roomid: number;
    online: number;
    live: boolean;
    closed: boolean;
    timeout: ReturnType<typeof setTimeout>;
    inflates: Inflates;
    send: (data: Buffer) => void;
    close: () => void;
    constructor(inflates: Inflates, roomid: number, { send, close, protover, key, authBody, uid, buvid }: {
        send: (data: Buffer) => void;
        close: () => void;
    } & LiveOptions);
    heartbeat(): void;
    getOnline(): Promise<number>;
}
export declare class KeepLive<Base extends typeof Live> extends EventEmitter {
    params: ConstructorParameters<Base>;
    closed: boolean;
    interval: number;
    timeout: number;
    connection: InstanceType<Base>;
    Base: Base;
    constructor(Base: Base, ...params: ConstructorParameters<Base>);
    connect(reconnect?: boolean): void;
    get online(): number;
    get roomid(): number;
    close(): void;
    heartbeat(): void;
    getOnline(): Promise<number>;
    send(data: Buffer): void;
}
export {};
