"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LiveTCPBase = void 0;
const net_1 = __importDefault(require("net"));
const common_1 = require("./common");
class LiveTCPBase extends common_1.Live {
    constructor(inflates, roomid, { host = 'broadcastlv.chat.bilibili.com', port = 2243, ...options } = {}) {
        const socket = net_1.default.connect(port, host);
        const send = (data) => {
            socket.write(data);
        };
        const close = () => this.socket.end();
        super(inflates, roomid, { send, close, ...options });
        this.i = 0;
        this.buffer = Buffer.alloc(0);
        socket.on('ready', () => this.emit('open'));
        socket.on('close', () => this.emit('close'));
        socket.on('error', (...params) => this.emit('_error', ...params));
        socket.on('data', buffer => {
            this.buffer = Buffer.concat([this.buffer, buffer]);
            this.splitBuffer();
        });
        this.socket = socket;
    }
    splitBuffer() {
        while (this.buffer.length >= 4 && this.buffer.readInt32BE(0) <= this.buffer.length) {
            const size = this.buffer.readInt32BE(0);
            const pack = this.buffer.slice(0, size);
            this.buffer = this.buffer.slice(size);
            this.i++;
            if (this.i > 5) {
                this.i = 0;
                this.buffer = Buffer.from(this.buffer);
            }
            this.emit('message', pack);
        }
    }
}
exports.LiveTCPBase = LiveTCPBase;
