/// <reference types="node" />
/// <reference types="ws" />
/// <reference types="node" />
/// <reference types="node" />
import { EventEmitter } from 'events';
import { Agent } from 'http';
import IsomorphicWebSocket from 'isomorphic-ws';
import { Inflates } from './buffer';
import { LiveOptions, Live } from './common';
export type WSOptions = LiveOptions & {
    address?: string;
    agent?: Agent;
};
export declare const isNode = true;
declare class WebSocket extends EventEmitter {
    ws: IsomorphicWebSocket;
    constructor(address: string, inflates: Inflates, ...args: any[]);
    get readyState(): 0 | 2 | 1 | 3;
    send(data: Buffer): void;
    close(code?: number, data?: string): void;
}
export declare class LiveWSBase extends Live {
    ws: InstanceType<typeof WebSocket>;
    constructor(inflates: Inflates, roomid: number, { address, agent, ...options }?: WSOptions);
}
export {};
